/*
 * Copyright 2016-present Open Networking Laboratory
 *
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 *
 *     http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 */

package org.onosproject.yang.gen.v1.http.netconfcentral.org.ns.siltest3.rev20110916.siltest3;

import org.onosproject.yang.gen.v1.http.netconfcentral.org.ns.siltest3.rev20110916.siltest3.u.UuUnion;
import org.onosproject.yang.gen.v1.http.netconfcentral.org.ns.siltest3.rev20110916.siltest3.u.UxUnion;
import org.onosproject.yangutils.translator.tojava.AugmentationHolder;

/**
 * Abstraction of an entity which represents the functionality of u.
 */
public interface U extends AugmentationHolder  {

    /**
     * Returns the attribute ux.
     *
     * @return value of ux
     */
    UxUnion ux();

    /**
     * Returns the attribute uy.
     *
     * @return value of uy
     */
    long uy();

    /**
     * Returns the attribute uz.
     *
     * @return value of uz
     */
    long uz();

    /**
     * Returns the attribute uu.
     *
     * @return value of uu
     */
    UuUnion uu();

    /**
     * Builder for u.
     */
    interface UBuilder {

        /**
         * Returns the attribute ux.
         *
         * @return value of ux
         */
        UxUnion ux();

        /**
         * Returns the attribute uy.
         *
         * @return value of uy
         */
        long uy();

        /**
         * Returns the attribute uz.
         *
         * @return value of uz
         */
        long uz();

        /**
         * Returns the attribute uu.
         *
         * @return value of uu
         */
        UuUnion uu();

        /**
         * Returns the builder object of ux.
         *
         * @param ux value of ux
         * @return builder object of ux
         */
        UBuilder ux(UxUnion ux);

        /**
         * Returns the builder object of uy.
         *
         * @param uy value of uy
         * @return builder object of uy
         */
        UBuilder uy(long uy);

        /**
         * Returns the builder object of uz.
         *
         * @param uz value of uz
         * @return builder object of uz
         */
        UBuilder uz(long uz);

        /**
         * Returns the builder object of uu.
         *
         * @param uu value of uu
         * @return builder object of uu
         */
        UBuilder uu(UuUnion uu);

        /**
         * Builds object of u.
         *
         * @return object of u.
         */
        U build();
    }
}